import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrTeacherclassroomscheduling {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  TeacherId!: bigint;
  ClassId!: bigint;
  WeekNum!: number;
  SubjectId!: bigint;
  Remark?: string;
  NextTriggerTime?: Date;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrTeacherclassroomschedulingSchema = defineEntity({
  class: IcrTeacherclassroomscheduling,
  comment: '教师课堂排班',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    TeacherId: p.bigint().name('TeacherId').comment('教师Id'),
    ClassId: p.bigint().name('ClassId').comment('班级Id'),
    WeekNum: p.integer().name('WeekNum').comment('周几'),
    SubjectId: p.bigint().name('SubjectId').comment('科目'),
    Remark: p.string().name('Remark').nullable().comment('备注'),
    NextTriggerTime: p.datetime().name('NextTriggerTime').length(3).nullable().comment('下次的触发时间'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
